#include ".\behaviorcreator.h"
//using namespace std;

BehaviorCreator::BehaviorCreator(int ParentChild, int Adults, int Kids, bool XSI, bool AVI,
								 int clusters, int exits, float ex[2][2], float peop[40][2],
								 CString l_floor, TCHAR old_path[], int factor) :
		numParentChild(ParentChild), numAdult(Adults), numKid(Kids), createXSI(XSI),
		createAVI(AVI), clusterClicks(clusters), exitClicks(exits), c_floor(l_floor),
		scaleFactor(factor) {
	for (int l=0; l<256; l++) {
		dir_path[l]=old_path[l];
	}
	SetCurrentDirectory(dir_path);
	for (int k=0; k<exitClicks; k++) {
		exit[k][0] = ex[k][0];
		exit[k][1] = ex[k][1];
	}
	for (int j=0; j<clusterClicks; j++) {
		people[j][0] = peop[j][0];
		people[j][1] = peop[j][1];
	}

	// Make the project files
	_mkdir("bProj");
	MakeSPJ(".\\bProj\\something.spj");
	MakeSWS(".\\bProj\\something.sws");
	MakeTemplateSWS(".\\bProj\\template.sws");

	// Make the State Machines
	_mkdir("bProj\\StateMachines");
	MakeStateMachines();

	// Make the piccolo code
	_mkdir("bProj\\Piccolo");
	MakeStartupPC();
	MakeGenericPiccolo();	// TODO: delete .pobj files - SCRATCH THAT ... JUST FIX THE FUNCTION SO IT'S NOT SO HUGE

	// Add the actors
    char c;
	_mkdir("bProj\\Content");
	_mkdir("bProj\\Content\\Actors");
	// import various actors into directories with same name (eg. Gold.xsi into bProj\Content\Actors\Gold)
	_mkdir("bProj\\Content\\Actors\\Archer");
	ifstream ifs1(".\\unchanged\\Archer.xsi", ios::in | ios::binary);
	ofstream ofs1(".\\bProj\\Content\\Actors\\Archer\\Archer.xsi", ios::out | ios::binary);
    assert(ifs1 && ofs1);
    while (ifs1.get(c))
		ofs1.put(c);
	ifs1.close();
	ofs1.close();
	_mkdir("bProj\\Content\\Actors\\Proxy");
	ifstream ifs2(".\\unchanged\\Proxy.xsi", ios::in | ios::binary);
	ofstream ofs2(".\\bProj\\Content\\Actors\\Proxy\\Proxy.xsi", ios::out | ios::binary);
    assert(ifs2 && ofs2);
    while (ifs2.get(c))
		ofs2.put(c);
	ifs2.close();
	ofs2.close();
	_mkdir("bProj\\Content\\Actors\\Floor");
	ifstream ifs3(c_floor, ios::in | ios::binary);
	//ifstream ifs3(".\\unchanged\\Floor.xsi", ios::in | ios::binary);
	ofstream ofs3(".\\bProj\\Content\\Actors\\Floor\\Floor.xsi", ios::out | ios::binary);
    assert(ifs3 && ofs3);
    while (ifs3.get(c))
		ofs3.put(c);
	ifs3.close();
	ofs3.close();
	_mkdir("bProj\\Content\\Actors\\Wall");
	ifstream ifs4(".\\unchanged\\Wall.xsi", ios::in | ios::binary);
	ofstream ofs4(".\\bProj\\Content\\Actors\\Wall\\Wall.xsi", ios::out | ios::binary);
    assert(ifs4 && ofs4);
    while (ifs4.get(c))
		ofs4.put(c);
	ifs4.close();
	ofs4.close();

	// Add the Worlds
	_mkdir("bProj\\Content\\Worlds");
	// import world.xsi file into the Worlds folder
	ifstream ifsw(".\\unchanged\\world.xsi", ios::in | ios::binary);
	ofstream ofsw(".\\bProj\\Content\\Worlds\\world.xsi", ios::out | ios::binary);
    assert(ifsw && ofsw);
    while (ifsw.get(c))
		ofsw.put(c);
	ifsw.close();
	ofsw.close();
}

// The empty destructor is fine
BehaviorCreator::~BehaviorCreator(void) {
}

// MakeSPJ is right if the only actors are Archer, Wall, Floor and Proxy
void BehaviorCreator::MakeSPJ(char *filename) {
	out.open(filename, fstream::out | fstream::trunc);
	out << "<?xml version=\"1.0\" encoding=\"US-ASCII\"?>\n"
		<< "<!-- Do not edit this computer generated file -->\n"
		<< "<!DOCTYPE project [\n"
		<< "<!ELEMENT project ((AssetTypes?),(ProjectWindow?))>\n"
		<< "<!ELEMENT AssetTypes (assetdef)*>\n"
		<< "<!ELEMENT assetdef (subtype)*>\n"
		<< "<!ATTLIST assetdef name CDATA #REQUIRED\n"
		<< "                   mask CDATA #REQUIRED\n"
		<< "                   build CDATA #IMPLIED\n"
		<< "                   editor CDATA #IMPLIED\n"
		<< "                   publish CDATA #IMPLIED\n"
		<< "                   constructor CDATA #IMPLIED>\n"
		<< "<!ELEMENT subtype (EMPTY)*>\n"
		<< "<!ATTLIST subtype name CDATA #REQUIRED\n"
		<< "                  build CDATA #IMPLIED\n"
		<< "                  editor CDATA #IMPLIED\n"
		<< "                  publish CDATA #IMPLIED\n"
		<< "                  constructor CDATA #IMPLIED>\n"
		<< "<!ELEMENT ProjectWindow (folder)*>\n"
		<< "<!ELEMENT folder (asset|file|filters|folder|property)*>\n"
		<< "<!ATTLIST folder name CDATA #REQUIRED\n"
		<< "                 type CDATA #IMPLIED\n"
		<< "                 path CDATA #IMPLIED\n"
		<< "                 recursive CDATA #IMPLIED>\n"
		<< "<!ELEMENT asset (EMPTY)*>\n"
		<< "<!ATTLIST asset name CDATA #REQUIRED>\n"
		<< "<!ELEMENT file (property)*>\n"
		<< "<!ATTLIST file path CDATA #REQUIRED\n"
		<< "               subtype CDATA #IMPLIED\n"
		<< "               excludebuild CDATA #IMPLIED\n"
		<< "               excludepublish CDATA #IMPLIED>\n"
		<< "<!ELEMENT filters (asset)*>\n"
		<< "<!ELEMENT property (EMPTY)*>\n"
		<< "<!ATTLIST property name CDATA #REQUIRED\n"
		<< "                   value CDATA #REQUIRED>\n"
		<< "]>\n"
		<< "<project>\n"
		<< "\n"
		<< "    <AssetTypes>\n"
		<< "        <assetdef name=\"Event\" mask=\"*.evt\"\n"
		<< "            editor=\"yes\"\n"
		<< "            constructor=\"single\"\n"
		<< "        >\n"
		<< "        </assetdef>\n"
		<< "        <assetdef name=\"TypeInfo\" mask=\"*.pti\"\n"
		<< "        >\n"
		<< "        </assetdef>\n"
		<< "        <assetdef name=\"HFSM\" mask=\"*.hfsm\"\n"
		<< "            editor=\"yes\"\n"
		<< "            build=\"yes\"\n"
		<< "            publish=\"yes\"\n"
		<< "            constructor=\"yes\"\n"
		<< "        >\n"
		<< "        </assetdef>\n"
		<< "        <assetdef name=\"Piccolo\" mask=\"*.pc\"\n"
		<< "            editor=\"yes\"\n"
		<< "            build=\"yes\"\n"
		<< "            publish=\"yes\"\n"
		<< "            constructor=\"yes\"\n"
		<< "        >\n"
		<< "        </assetdef>\n"
		<< "        <assetdef name=\"XSI\" mask=\"*.xsi\"\n"
		<< "        >\n"
		<< "            <subtype name=\"World\" editor=\"yes\" />\n"
		<< "            <subtype name=\"Actor\" editor=\"yes\" />\n"
		<< "        </assetdef>\n"
		<< "        <assetdef name=\"ConstSet\" mask=\"*.pcs\"\n"
		<< "            editor=\"yes\"\n"
		<< "            constructor=\"yes\"\n"
		<< "        >\n"
		<< "        </assetdef>\n"
		<< "    </AssetTypes>\n"
		<< "\n"
		<< "    <ProjectWindow>\n"
		<< "        <folder name=\"Content\" path=\".\\content\"\n"
		<< "            type=\"import\" recursive=\"yes\">\n"
		<< "            <filters>\n"
		<< "                <asset name=\"XSI\"/>\n"
		<< "            </filters>\n"
		<< "            <folder name=\"Actors\">\n"
		<< "                <folder name=\"Archer\">\n"
		<< "                    <file path=\"Archer.xsi\" subtype=\"Actor\">\n"
		<< "                    </file>\n"
		<< "                </folder>\n"
		<< "                <folder name=\"Proxy\">\n"
		<< "                    <file path=\"Proxy.xsi\" subtype=\"Actor\">\n"
		<< "                    </file>\n"
		<< "                </folder>\n"
		<< "                <folder name=\"Wall\">\n"
		<< "                    <file path=\"Wall.xsi\" subtype=\"Actor\">\n"
		<< "                    </file>\n"
		<< "                </folder>\n"
		<< "                <folder name=\"Floor\">\n"
		<< "                    <file path=\"Floor.xsi\" subtype=\"Actor\">\n"
		<< "                    </file>\n"
		<< "                </folder>\n"
		<< "            </folder>\n"
		<< "        </folder>\n"
		<< "        <folder name=\"Piccolo\" path=\"Piccolo\">\n"
		<< "            <asset name=\"Piccolo\"/>\n"
		<< "            <asset name=\"ConstSet\"/>\n"
		<< "            <asset name=\"TypeInfo\"/>\n"
		<< "            <file path=\"crowd.pc\">\n"
		<< "            </file>\n"
		<< "            <file path=\"drive_constants.pcs\">\n"
		<< "            </file>\n"
		<< "            <file path=\"drive_event.pti\">\n"
		<< "            </file>\n"
		<< "            <file path=\"drive_typeinfo.pti\">\n"
		<< "            </file>\n"
		<< "            <file path=\"flock.pc\">\n"
		<< "            </file>\n"
		<< "            <file path=\"helper.pc\">\n"
		<< "            </file>\n"
		<< "            <file path=\"helperdata.pcs\">\n"
		<< "            </file>\n"
		<< "            <file path=\"imgcap.pc\">\n"
		<< "            </file>\n"
		<< "            <file path=\"mocap.pc\">\n"
		<< "            </file>\n"
		<< "            <file path=\"piccolo.pti\">\n"
		<< "            </file>\n"
		<< "            <file path=\"rtk.pc\">\n"
		<< "            </file>\n"
		<< "            <file path=\"startup.pc\">\n"
		<< "            </file>\n"
		<< "        </folder>\n"
		<< "        <folder name=\"State Machines\" path=\"StateMachines\">\n"
		<< "            <asset name=\"HFSM\"/>\n"
		<< "            <asset name=\"Event\"/>\n"
		<< "            <file path=\"cluster.hfsm\">\n"
		<< "            </file>\n"
		<< "            <file path=\"events.evt\">\n"
		<< "            </file>\n"
		<< "            <file path=\"handler.hfsm\">\n"
		<< "            </file>\n"
		//<< "            <file path=\"key.hfsm\">\n"
		//<< "            </file>\n"
		<< "        </folder>\n"
		<< "    </ProjectWindow>\n"
		<< "\n"
		<< "\n"
		<< "</project>\n";
	out.close();
}

// MakeSWS is right if the only actors are Archer, Wall, Floor and Proxy
void BehaviorCreator::MakeSWS(char *filename) {
	out.open(filename, fstream::out | fstream::trunc);
	out << "section \"WorkspaceBreakpoints\"\n"
		<< "\"NumBreakpoints\" (all) =(integer) 0\n"
		<< "\"Version\" (all) =(integer) 2\n"
		<< "\n"
		<< "section \"WorkspaceDebuggerWndPos\"\n"
		<< "\"Position\" (all) =(binary) x01,x00,x00,x00,x45,x00,x00,x00,x45,x00,x00,x00,xc5,x02,x00,x00,x25,x02,x00,\n"
		<< "x00\n"
		<< "\n"
		<< "section \"WorkspaceEditors\"\n"
		<< "\"Editor0\" (all) =(binary) x0a,x00,x00,x00,x73,x74,x61,x72,x74,x75,x70,x2e,x70,x63,xff,xff,xff,xff,x02,\n"
		<< "x00,x00,x00,x00,x00,x00,x00,x9e,x02,x00,x00,xff,xff,xff,xff,xff,xff,xff,xff,\n"
		<< "x00,x00,x00,x00,x00,x00,x00,x00,x80,x02,x00,x00,xe0,x01,x00,x00,x07,x00,x00,\n"
		<< "x00,x50,x69,x63,x63,x6f,x6c,x6f,x08,x00,x00,x00,x2f,x50,x69,x63,x63,x6f,x6c,\n"
		<< "x6f,x29,x00,x00,x00,x48,x3a,x5c,x62,x65,x68,x61,x76,x69,x6f,x75,x72,x5c,x45,\n"
		<< "x78,x31,x5f,x48,x65,x6c,x6c,x6f,x5c,x50,x69,x63,x63,x6f,x6c,x6f,x5c,x73,x74,\n"
		<< "x61,x72,x74,x75,x70,x2e,x70,x63\n"
		<< "\"Editor1\" (all) =(binary) x08,x00,x00,x00,x6b,x65,x79,x2e,x68,x66,x73,x6d,xff,xff,xff,xff,x01,x00,x00,\n"
		<< "x00,xff,xff,xff,xff,xff,xff,xff,xff,xff,xff,xff,xff,xff,xff,xff,xff,x00,x00,\n"
		<< "x00,x00,xff,xff,xff,xff,x80,x02,x00,x00,xdf,x01,x00,x00,x04,x00,x00,x00,x48,\n"
		<< "x46,x53,x4d,x0f,x00,x00,x00,x2f,x53,x74,x61,x74,x65,x20,x4d,x61,x63,x68,x69,\n"
		<< "x6e,x65,x73,x2d,x00,x00,x00,x48,x3a,x5c,x62,x65,x68,x61,x76,x69,x6f,x75,x72,\n"
		<< "x5c,x45,x78,x31,x5f,x48,x65,x6c,x6c,x6f,x5c,x53,x74,x61,x74,x65,x4d,x61,x63,\n"
		<< "x68,x69,x6e,x65,x73,x5c,x6b,x65,x79,x2e,x68,x66,x73,x6d\n"
		<< "\"Editor2\" (all) =(binary) x00,x00,x00,x00,x6f,x6c,x6f,x20,x01,x00,x00,x00,xa0,x00,x00,x00,x9e,x02,x00,\n"
		<< "x00,xff,xff,xff,xff,xff,xff,xff,xff,x2e,x00,x00,x00,x2e,x00,x00,x00,xae,x02,\n"
		<< "x00,x00,x0e,x02,x00,x00,x00,x00,x00,x00,x00,x00,x00,x00,x00,x00,x00,x00\n"
		<< "\"NumEditors\" (all) =(integer) 3\n"
		<< "\"Version\" (all) =(integer) 3\n"
		<< "\n"
		<< "section \"WorkspaceProjectWindow\"\n"
		<< "\"FolderID0\" (all) =(text) \"/Content\"\n"
		<< "\"FolderID1\" (all) =(text) \"/Content/Actors\"\n"
		<< "\"FolderID2\" (all) =(text) \"/Content/Actors/Archer\"\n"
		<< "\"FolderID3\" (all) =(text) \"/Content/Actors/Proxy\"\n"
		<< "\"FolderID4\" (all) =(text) \"/Content/Actors/Floor\"\n"
		<< "\"FolderID5\" (all) =(text) \"/Content/Actors/Wall\"\n"
		<< "\"FolderID6\" (all) =(text) \"/Piccolo\"\n"
		<< "\"FolderID7\" (all) =(text) \"/State Machines\"\n"
		<< "\"NumFolders\" (all) =(integer) 8\n"
		<< "\n"
		<< "section \"WorkspaceScriptPos\"\n"
		<< "\"NumScriptPos\" (all) =(integer) 1\n"
		<< "\"ScriptPos0\" (all) =(binary) x01,x00,x00,x00,x2e,x00,x00,x00,x2e,x00,x00,x00,xae,x02,x00,x00,x0e,x02,x00,\n"
		<< "x00\n"
		<< "\n"
		<< "section \"WorkspaceWatchVars\"\n"
		<< "\"NumWatchVars\" (all) =(integer) 0\n"
		<< "\n";
	out.close();
}

// MakeTemplateSWS is finished
void BehaviorCreator::MakeTemplateSWS(char *filename) {
	out.open(filename, fstream::out | fstream::trunc);
	out << "section \"WorkspaceBreakpoints\"\n"
		<< "\"NumBreakpoints\" (all) =(integer) 0\n"
		<< "\"Version\" (all) =(integer) 2\n"
		<< "\n"
		<< "section \"WorkspaceEditors\"\n"
		<< "\"Editor0\" (all) =(binary) x08,x00,x00,x00,x63,x72,x6f,x77,x64,x2e,x70,x63,xff,xff,xff,xff,x01,x00,x00,\n"
		<< "x00,xff,xff,xff,xff,xff,xff,xff,xff,xff,xff,xff,xff,xff,xff,xff,xff,x00,x00,\n"
		<< "x00,x00,x00,x00,x00,x00,xc1,x02,x00,x00,xb6,x02,x00,x00,x07,x00,x00,x00,x50,\n"
		<< "x69,x63,x63,x6f,x6c,x6f,x08,x00,x00,x00,x2f,x50,x69,x63,x63,x6f,x6c,x6f,x44,\n"
		<< "x00,x00,x00,x43,x3a,x5c,x53,x6f,x66,x74,x69,x6d,x61,x67,x65,x5c,x42,x45,x48,\n"
		<< "x41,x56,x49,x4f,x52,x5f,x31,x2e,x35,x5c,x50,x72,x6f,x6a,x65,x63,x74,x54,x65,\n"
		<< "x6d,x70,x6c,x61,x74,x65,x73,x5c,x42,x65,x68,x61,x76,x69,x6f,x72,x5c,x50,x69,\n"
		<< "x63,x63,x6f,x6c,x6f,x5c,x63,x72,x6f,x77,x64,x2e,x70,x63\n"
		<< "\"NumEditors\" (all) =(integer) 1\n"
		<< "\"Version\" (all) =(integer) 3\n"
		<< "\n"
		<< "section \"WorkspaceProjectWindow\"\n"
		<< "\"FolderID0\" (all) =(text) \"/Piccolo\"\n"
		<< "\"NumFolders\" (all) =(integer) 1\n"
		<< "\n"
		<< "section \"WorkspaceScriptPos\"\n"
		<< "\"NumScriptPos\" (all) =(integer) 0\n"
		<< "\n"
		<< "section \"WorkspaceWatchVars\"\n"
		<< "\"NumWatchVars\" (all) =(integer) 0\n\n";
	out.close();
}

// MakeStateMachines is simply copying old state machines over.  Make sure this is correct for the needed task
void BehaviorCreator::MakeStateMachines() {
	ifstream in1(".\\unchanged\\handler.hfsm", ios::in | ios::binary);
	ofstream out1(".\\bProj\\StateMachines\\handler.hfsm", ios::out | ios::binary);
    assert(in1 && out1);

    char c;

    while (in1.get(c))
		out1.put(c);

	in1.close();
	out1.close();


	ifstream ifs(".\\unchanged\\handler.chfsm", ios::in | ios::binary);
	ofstream ofs(".\\bProj\\StateMachines\\handler.chfsm", ios::out | ios::binary);
    assert(ifs && ofs);

    //char c;

    while (ifs.get(c))
		ofs.put(c);

	ifs.close();
	ofs.close();
	

	ifstream in3(".\\unchanged\\cluster.hfsm", ios::in | ios::binary);
	ofstream out3(".\\bProj\\StateMachines\\cluster.hfsm", ios::out | ios::binary);
    assert(in3 && out3);

    //char c;

    while (in3.get(c))
		out3.put(c);

	in3.close();
	out3.close();

	ifstream ifs3(".\\unchanged\\cluster.chfsm", ios::in | ios::binary);
	ofstream ofs3(".\\bProj\\StateMachines\\cluster.chfsm", ios::out | ios::binary);
    assert(ifs3 && ofs3);

    //char c;

    while (ifs3.get(c))
		ofs3.put(c);
	
	// events.evt is correct
	out.open(".\\bProj\\StateMachines\\events.evt", fstream::out | fstream::trunc); {
	out << "<?xml version=\"1.0\" encoding=\"US-ASCII\"?>\n"
		<< "<!-- Do not edit this computer generated file -->\n"
		<< "<!DOCTYPE events [\n"
		<< "<!ELEMENT events (category)*>\n"
		<< "<!ELEMENT category (event)*>\n"
		<< "<!ATTLIST category\n"
		<< "    name CDATA #REQUIRED\n"
		<< "    value CDATA #REQUIRED>\n"
		<< "<!ELEMENT event EMPTY>\n"
		<< "<!ATTLIST event\n"
		<< "    name CDATA #REQUIRED\n"
		<< "    value CDATA #REQUIRED>\n"
		<< "]>\n"
		<< "<events>\n"
		<< "\n"
		<< "    <category name=\"Drive\" value=\"0\">\n"
		<< "        <event name=\"DM_ACTIVITY\" value=\"1\"/>\n"
		<< "        <event name=\"DM_ACTIVITY_3DPATHPEAK\" value=\"65544\"/>\n"
		<< "        <event name=\"DM_ACTIVITY_ADDED\" value=\"65552\"/>\n"
		<< "        <event name=\"DM_ACTIVITY_APPROACH\" value=\"65546\"/>\n"
		<< "        <event name=\"DM_ACTIVITY_COLLISION\" value=\"65542\"/>\n"
		<< "        <event name=\"DM_ACTIVITY_FINISHED\" value=\"65537\"/>\n"
		<< "        <event name=\"DM_ACTIVITY_FOLLOWCHANGE\" value=\"65548\"/>\n"
		<< "        <event name=\"DM_ACTIVITY_IKLOCOCONTACT\" value=\"65550\"/>\n"
		<< "        <event name=\"DM_ACTIVITY_IKLOCONEXTCON\" value=\"65549\"/>\n"
		<< "        <event name=\"DM_ACTIVITY_IKLOCONOCONTACT\" value=\"65551\"/>\n"
		<< "        <event name=\"DM_ACTIVITY_LOCOCREATED\" value=\"65539\"/>\n"
		<< "        <event name=\"DM_ACTIVITY_LOCOFAILED\" value=\"65538\"/>\n"
		<< "        <event name=\"DM_ACTIVITY_LOCOSTOPPED\" value=\"65540\"/>\n"
		<< "        <event name=\"DM_ACTIVITY_MANIPFAILED\" value=\"65541\"/>\n"
		<< "        <event name=\"DM_ACTIVITY_RECEIVECOL\" value=\"65543\"/>\n"
		<< "        <event name=\"DM_ACTIVITY_REMOVED\" value=\"65568\"/>\n"
		<< "        <event name=\"DM_ACTIVITY_RETREAT\" value=\"65547\"/>\n"
		<< "        <event name=\"DM_ACTIVITY_TRANSDATA\" value=\"65545\"/>\n"
		<< "        <event name=\"DM_KEYBOARD_KEYDOWN\" value=\"131073\"/>\n"
		<< "        <event name=\"DM_KEYBOARD_KEYUP\" value=\"131074\"/>\n"
		<< "        <event name=\"DM_MOUSE_LDOWN\" value=\"196610\"/>\n"
		<< "        <event name=\"DM_MOUSE_LUP\" value=\"196611\"/>\n"
		<< "        <event name=\"DM_MOUSE_MDOWN\" value=\"196612\"/>\n"
		<< "        <event name=\"DM_MOUSE_MOVE\" value=\"196609\"/>\n"
		<< "        <event name=\"DM_MOUSE_MUP\" value=\"196613\"/>\n"
		<< "        <event name=\"DM_MOUSE_RDOWN\" value=\"196614\"/>\n"
		<< "        <event name=\"DM_MOUSE_RUP\" value=\"196615\"/>\n"
		<< "        <event name=\"DM_PING\" value=\"123\"/>\n"
		<< "        <event name=\"DM_SKILL_EVENT\" value=\"262144\"/>\n"
		<< "        <event name=\"DM_CROWD_PFD\" value=\"327680\"/>\n"
		<< "        <event name=\"DM_CROWD_SKIP\" value=\"327681\"/>\n"
		<< "    </category>\n\n\n"
		<< "</events>\n";
	}
	out.close();
}

// MakeStartupPC needs to be updated for the task at hand
void BehaviorCreator::MakeStartupPC(){
	int totalPeople = numParentChild*2+numAdult+numKid;
	// this will weed out where the total clustered groups is greater than the total people
	int clustered = (totalPeople>=clusterClicks*10?clusterClicks:totalPeople/10);
	int nonClustered = (totalPeople>clustered*10?totalPeople-10*clustered:0);
	int exitsToMake = 2-exitClicks;

	out.open(".\\bProj\\Piccolo\\startup.pc", fstream::out | fstream::trunc); {
	out << "use constants \"drive_constants\";\n"
		<< "function main() {\n"
		<< "	engine.RunScript(\"rtk\", nil);\n"
		<< "	engine.LoadWorld(\"world.xsi\");\n"
		<< "	global var world = engine.GetCurrentWorld();\n"
		<< "	global var FAR = new DrvVector(1000,1000,10000);\n"
		<< "	global var TotalPeople=" << totalPeople << ";\n"
		<< "	global var dumpToXSI = " << (int)createXSI << ";\n"
		<< "	global var dumpToAVI = " << (int)createAVI << ";\n"
		<< "	var terrain = world.GetActorByName(\"Floor0\");\n"
		<< "	var floor = terrain.GetNodeByName(\"Floor\");\n"
		<< "	var floorisflat = (floor.GetFloor().top == 0);\n"
		<< "	var v0, count=0, actor;\n"
		<< "	// first exit\n";
	if (exitsToMake==0) {
		out << "	global var va = new DrvVector(" << exit[0][0]+5 << ",0," << exit[0][1] << ");\n"
			<< "	global var vb = new DrvVector(" << exit[0][0]-5 << ",0," << exit[0][1] << ");\n"
			<< "	// second exit\n"
			<< "	global var va2 = new DrvVector(" << exit[1][0]+5 << ",0," << exit[1][1] << ");\n"
			<< "	global var vb2 = new DrvVector(" << exit[1][0]-5 << ",0," << exit[1][1] << ");\n";
	} else if (exitsToMake==1) {
		out << "	global var va = new DrvVector(" << exit[0][0]+5 << ",0," << exit[0][1] << ");\n"
			<< "	global var vb = new DrvVector(" << exit[0][0]-5 << ",0," << exit[0][1] << ");\n"
			<< "	// second exit\n"
			<< "	global var va2 = new DrvVector(5,0,-65);\n"
			<< "	global var vb2 = new DrvVector(-5,0,-65);\n";
	} else {
		out << "	global var va = new DrvVector(5,0,65);\n"
			<< "	global var vb = new DrvVector(-5,0,65);\n"
			<< "	// second exit\n"
			<< "	global var va2 = new DrvVector(5,0,-65);\n"
			<< "	global var vb2 = new DrvVector(-5,0,-65);\n";
	}
	out << "\n"
		<< "	var mesh = floor.GetMesh();\n"
		<< "	if(mesh == nil)\n"
		<< "		mesh = floor.GetParent().GetMesh();\n"
		<< "\n"
		<< "	var vmin = new DrvVector(100000, 100000, 10000000);\n"
		<< "	var vmax = new DrvVector(-100000, -100000, -10000000);\n"
		<< "	var v, n = mesh.nvertices;\n"
		<< "	for(var c = 0; c < n; c++) {\n"
		<< "		v = mesh.GetVertex(c);\n"
		<< "		\n"
		<< "		if(v.x < vmin.x)\n"
		<< "			vmin.x = v.x;\n"
		<< "		if(v.y < vmin.y)\n"
		<< "			vmin.y = v.y;\n"
		<< "		if(v.z < vmin.z)\n"
		<< "			vmin.z = v.z;\n"
		<< "		if(v.x > vmax.x)\n"
		<< "			vmax.x = v.x;\n"
		<< "		if(v.y > vmax.y)\n"
		<< "			vmax.y = v.y;\n"
		<< "		if(v.z > vmax.z)\n"
		<< "			vmax.z = v.z;\n"
		<< "	}\n"
		<< "\n"
		<< "	var w = vmax.z - vmin.z;\n"
		<< "	var h = vmax.x - vmin.x;\n"
		<< "\n"
		<< "	var dimw = new Integer(5*w/5 + 0.5);	// second 5 instead of radius\n"
		<< "	var dimh = new Integer(5*h/5 + 0.5);\n"
		<< "\n"
		<< "	if(dimw < 400)\n"
		<< "		dimw = 400;\n"
		<< "	if(dimh < 400)\n"
		<< "		dimh = 400;\n"
		<< "\n"
		<< "	vmin.MultiplyTransform(vmin, floor.GetGlobalTransform());\n"
		<< "\n"
		<< "	var x = vmin.z;\n"
		<< "	var y = vmin.x;\n"
		<< "\n"
		<< "	for (var i=0; i<" << nonClustered << "; i++) {\n"
		<< "		var tempActor = engine.LoadActor(\"Archer\", world);\n"
		<< "		AddClusterData(tempActor, \"NonClustered\");\n"
		<< "	}\n"
		<< "	var placed = new List();\n";
	for (int i=0; i<clustered; i++) {
		out << "	v0 = new DrvVector(" << people[i][0] << ",0," << people[i][1] << ");\n"
			<< "	MyCluster(v0, \"Archer\", \"Clustered\");\n";
	}
	out << "	global var nonClusteredList = ExtractCluster(\"NonClustered\");\n"
		<< "	for (actor = nonClusteredList.First(); actor != nil; actor = nonClusteredList.Next()) {\n"
		<< "		var mat = actor.GetRootNode().GetGlobalTransform();\n"
		<< "		mat.position.x = -60 + Math.Rand()%120;\n"
		<< "		mat.position.z = -60 + Math.Rand()%120;\n"
		<< "		actor.GetRootNode().SetGlobalTransform(mat);\n"
		<< "	}\n"
		<< "	global var flock = InitializeSimpleFlock(\"Archer\", 0.45, \"walk\", 5, 15, 60, floor, va, vb);\n"
		<< "	flock.CreateNavigationFunction(1, floor, dimw, dimh, 5, 5, va2, vb2);\n"
		<< "	i = 0;\n"
		<< "	global var glist = world.GetActorList(\"Archer\");\n"
		<< "	global var myList = world.GetActorList(\"Archer\");\n"
		<< "	var pfd1, pfd2;\n"
		<< "	v0 = new DrvVector(0,0,1);\n"
		<< "	for (actor = glist.First(); actor != nil; actor = glist.Next()) {\n"
		<< "		if ((i%2 == 0) && (i < 30)) {	// make Child\n"
		<< "			pfd1 = actor.pfd;\n"
		<< "			actor.fa.SetTargetSkill(\"jog\", 1500, 1);\n"
		<< "		} else if (i < 30) {	// make Parent\n"
		<< "			pfd2 = actor.pfd;\n"
		<< "			flock.SetLeaderFollower(pfd1,pfd2,v0,2);\n"
		<< "		} else if (count < 30) {	// make Adult\n"
		<< "			count++;\n"
		<< "		} else {	// make Kid\n"
		<< "			actor.fa.SetTargetSkill(\"jog\", 1500, 1);\n"
		<< "		}\n"
		<< "		flock.EnableFloorCeiling(actor.pfd, TRUE, 0, 15);\n"
		<< "		ClosestExit(actor, va, vb, va2, vb2);\n"
		<< "		//Console.PrintNl(\"i=\", i, \", z=\", mat.position.z, \", nav=\", actor.nav);\n"
		<< "		i++;\n"
		<< "		// mix up the cycle start time\n"
		<< "		actor.fa.ikla.loco.skilltime = Math.Rand()%1000;\n"
		<< "		// add a pose for stopping\n"
		<< "		var stop = world.GetSkillCache().GetSkill(\"stand\", actor);\n"
		<< "		actor.fa.ikla.loco.SetStopSkill(stop);\n"
		<< "	}\n"
		<< "	count = 0;\n"
		<< "	var camera = world.GetCamera();\n"
		<< "	camera.fovy = 60;\n"
		<< "	engine.SetupCamera(camera);\n"
		<< "	var T;\n"
		<< "	T = new DrvTransform();\n"
		<< "	T.Identity();\n"
		<< "	T.position.x = " << -scaleFactor*100.0f/70.0f << ";\n"
		<< "	T.position.y = " << scaleFactor*20.0f/70.0f << ";\n"
		<< "	T.position.z = " << scaleFactor*100.0f/70.0f << ";\n"
		<< "	T.rotation.y = -0.42;\n"
		<< "	engine.PositionCamera(T);\n"
		<< "\n"
		<< "	world.AddPiccoloActivityByName(\"Poll\");\n"
		<< "\n"
		<< "	if (dumpToAVI==1) {\n"
		<< "		InitializeRecord(24); \n"
		<< "		OpenMovie(\"test.avi\", 24); \n"
		<< "		StartMovieCapture();\n"
		<< "	}\n"
		<< "	if (dumpToXSI==1) {\n"
		<< "		InitializeRecord(24);\n"
		<< "		for(actor = glist.First(); actor != nil; actor = glist.Next()) {\n"
		<< "			if ((actor.pfd == nil)||(actor.pfd==\"Null\")) continue;\n"
		<< "			SubmitActor(\"h:\\mocap.xsi\", actor); \n"
		<< "		}\n"
		<< "		StartRecord();\n"
		<< "	}\n"
		<< "}\n"
		<< "\n"
		<< "function Poll(activity, time, world) {\n"
		<< "	var actor, pfd;\n"
		<< "	var steering = new Float(), speed = new Float(), target = new DrvVector(0,0,0);\n"
		<< "	for (actor = myList.First(); actor != nil; actor = myList.Next()) {\n"
		<< "		if (DistToExit(actor,va, vb, va2, vb2) < 5) {\n"
		<< "			actor.SetScale(0);\n"
		<< "			TotalPeople--;\n"
		<< "			if ((TotalPeople <= 0)&&(dumpToAVI==1)) {\n"
		<< "				CloseMovie();\n"
		<< "				RuntimeStop();\n"
		<< "			}\n"
		<< "			else if ((TotalPeople <= 0)&&(dumpToXSI==1)) {\n"
		<< "				CloseRecord();\n"
		<< "				RuntimeStop();\n"
		<< "			}\n"
		<< "			else if (TotalPeople <=0) {\n"
		<< "				RuntimeStop();\n"
		<< "			}\n"
		<< "			myList.Delete();\n"
		<< "			var mat = actor.GetRootNode().GetGlobalTransform();\n"
		<< "			mat.position = FAR;\n"
		<< "			actor.GetRootNode().SetGlobalTransform(mat);\n"
		<< "		}\n"
		<< "	}\n"
		<< "}\n"
		<< "\n"
		<< "function ClosestExit(actor, va, vb, va2, vb2) {\n"
		<< "	// checks actor's position versus the two exits\n"
		<< "	// if closer to va/vb, sets actor.nav to 0, else 1\n"
		<< "	var d1,d2,d3,d4,mat;\n"
		<< "	mat = actor.GetRootNode().GetGlobalTransform();\n"
		<< "	d1 = Math.Sqrt((va.x-mat.position.x)*(va.x-mat.position.x)+(va.z-mat.position.z)*(va.z-mat.position.z));\n"
		<< "	d2 = Math.Sqrt((vb.x-mat.position.x)*(vb.x-mat.position.x)+(vb.z-mat.position.z)*(vb.z-mat.position.z));\n"
		<< "	d3 = Math.Sqrt((va2.x-mat.position.x)*(va2.x-mat.position.x)+(va2.z-mat.position.z)*(va2.z-mat.position.z));\n"
		<< "	d4 = Math.Sqrt((vb2.x-mat.position.x)*(vb2.x-mat.position.x)+(vb2.z-mat.position.z)*(vb2.z-mat.position.z));\n"
		<< "\n"
		<< "	var l1, l2;\n"
		<< "	if (d1 < d2)\n"
		<< "		l1 = d1;\n"
		<< "	else\n"
		<< "		l1 = d2;\n"
		<< "\n"
		<< "	if (d3 < d4)\n"
		<< "		l2 = d3;\n"
		<< "	else\n"
		<< "		l2 = d4;\n"
		<< "\n"
		<< "	if (l1 <= l2)\n"
		<< "		actor.nav = 0;\n"
		<< "	else\n"
		<< "		actor.nav = 1;\n"
		<< "}\n"
		<< "\n"
		<< "function DistToExit(actor, va, vb, va2, vb2) {\n"
		<< "	// checks actor's position versus the two exits\n"
		<< "	// if closer to va/vb, sets actor.nav to 0, else 1\n"
		<< "	var d1,d2,d3,d4,mat;\n"
		<< "	mat = actor.GetRootNode().GetGlobalTransform();\n"
		<< "	d1 = Math.Sqrt((va.x-mat.position.x)*(va.x-mat.position.x)+(va.z-mat.position.z)*(va.z-mat.position.z));\n"
		<< "	d2 = Math.Sqrt((vb.x-mat.position.x)*(vb.x-mat.position.x)+(vb.z-mat.position.z)*(vb.z-mat.position.z));\n"
		<< "	d3 = Math.Sqrt((va2.x-mat.position.x)*(va2.x-mat.position.x)+(va2.z-mat.position.z)*(va2.z-mat.position.z));\n"
		<< "	d4 = Math.Sqrt((vb2.x-mat.position.x)*(vb2.x-mat.position.x)+(vb2.z-mat.position.z)*(vb2.z-mat.position.z));\n"
		<< "\n"
		<< "	var l1, l2;\n"
		<< "	if (d1 < d2)\n"
		<< "		l1 = d1;\n"
		<< "	else\n"
		<< "		l1 = d2;\n"
		<< "\n"
		<< "	if (d3 < d4)\n"
		<< "		l2 = d3;\n"
		<< "	else\n"
		<< "		l2 = d4;\n"
		<< "\n"
		<< "	if (l1 <= l2)\n"
		<< "		return l1;\n"
		<< "	else\n"
		<< "		return l2;\n"
		<< "}\n"
		<< "\n"
		<< "function MyCluster(center, actorclass, clustername) {\n"
		<< "	var actor, mat, v0;\n"
		<< "\n"
		<< "	for (var i=-180.0; i<180.0; i+=36) {\n"
		<< "		actor = engine.LoadActor(actorclass, world);\n"
		<< "		mat = actor.GetRootNode().GetGlobalTransform();\n"
		<< "		mat.position.x = center.x+15*Math.Cos(i/180.0*PI);\n"
		<< "		mat.position.z = center.z+15*Math.Sin(i/180.0*PI);\n"
		<< "		actor.GetRootNode().SetGlobalTransform(mat);\n"
		<< "		AddClusterData(actor, clustername);\n"
		<< "	}\n"
		<< "}\n";
	}
	out.close();
}
void BehaviorCreator::MakeGenericPiccolo() {
	ifstream in1(".\\unchanged\\rtk.pc", ios::in | ios::binary);
	ofstream out1(".\\bProj\\Piccolo\\rtk.pc", ios::out | ios::binary);
    assert(in1 && out1);

    char c;

    while (in1.get(c))
		out1.put(c);

	in1.close();
	out1.close();


	ifstream in2(".\\unchanged\\piccolo.pti", ios::in | ios::binary);
	ofstream out2(".\\bProj\\Piccolo\\piccolo.pti", ios::out | ios::binary);
    assert(in2 && out2);

    while (in2.get(c))
		out2.put(c);

	in2.close();
	out2.close();


	ifstream in3(".\\unchanged\\mocap.pc", ios::in | ios::binary);
	ofstream out3(".\\bProj\\Piccolo\\mocap.pc", ios::out | ios::binary);
    assert(in3 && out3);

    while (in3.get(c))
		out3.put(c);

	in3.close();
	out3.close();


	ifstream in4(".\\unchanged\\imgcap.pc", ios::in | ios::binary);
	ofstream out4(".\\bProj\\Piccolo\\imgcap.pc", ios::out | ios::binary);
    assert(in4 && out4);

    while (in4.get(c))
		out4.put(c);

	in4.close();
	out4.close();

	out.open(".\\bProj\\Piccolo\\helperdata.pcs", fstream::out | fstream::trunc); {
	out << "const DM_PING = 123;\n";
	}
	out.close();


	ifstream in5(".\\unchanged\\helper.pc", ios::in | ios::binary);
	ofstream out5(".\\bProj\\Piccolo\\helper.pc", ios::out | ios::binary);
    assert(in5 && out5);

    while (in5.get(c))
		out5.put(c);

	in5.close();
	out5.close();


	ifstream in6(".\\unchanged\\flock.pc", ios::in | ios::binary);
	ofstream out6(".\\bProj\\Piccolo\\flock.pc", ios::out | ios::binary);
    assert(in6 && out6);

    while (in6.get(c))
		out6.put(c);

	in6.close();
	out6.close();


	ifstream in7(".\\unchanged\\drive_typeinfo.pti", ios::in | ios::binary);
	ofstream out7(".\\bProj\\Piccolo\\drive_typeinfo.pti", ios::out | ios::binary);
    assert(in7 && out7);

    while (in7.get(c))
		out7.put(c);

	in7.close();
	out7.close();

	out.open(".\\bProj\\Piccolo\\drive_event.pti", fstream::out | fstream::trunc); {
	out << "<?xml version=\"1.0\" encoding=\"US-ASCII\"?>\n"
		<< "<!-- Do not edit this computer generated file -->\n"
		<< "<typeinfo>\n"
		<< "    <class name=\"Event\">\n"
		<< "        <property name=\"msg\"/>\n"
		<< "        <property name=\"data\"/>\n"
		<< "        <property name=\"object\"/>\n"
		<< "    </class>\n"
		<< "</typeinfo>\n";
	}
	out.close();


	ifstream in8(".\\unchanged\\drive_constants.pcs", ios::in | ios::binary);
	ofstream out8(".\\bProj\\Piccolo\\drive_constants.pcs", ios::out | ios::binary);
    assert(in8 && out8);

    while (in8.get(c))
		out8.put(c);

	in8.close();
	out8.close();


	ifstream in9(".\\unchanged\\crowd.pc", ios::in | ios::binary);
	ofstream out9(".\\bProj\\Piccolo\\crowd.pc", ios::out | ios::binary);
    assert(in9 && out9);

    while (in9.get(c))
		out9.put(c);

	in9.close();
	out9.close();
}