// OpenGLControl.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "math.h"
#include "OpenGLDialog.h"
#include "OpenGLControl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COpenGLControl

COpenGLControl::COpenGLControl() {
	dc = NULL;
	m_floor = "unchanged\\floor.xsi";
	rotation = 0.0f;
	scaleFactor = 0.0f;
	exitsMarked = clustersMarked = exitArrayVal = peopleArrayVal = 0;
}

COpenGLControl::~COpenGLControl() {
	if (dc) {
		delete dc;
	}
}


BEGIN_MESSAGE_MAP(COpenGLControl, CWnd)
	//{{AFX_MSG_MAP(COpenGLControl)
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_CREATE()
	ON_WM_ERASEBKGND()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten COpenGLControl 


void COpenGLControl::InitGL() {
	glShadeModel(GL_SMOOTH);
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
	glClearDepth(1.0f);							
	//glEnable(GL_DEPTH_TEST);					
	glDepthFunc(GL_LEQUAL);	
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	createFloorPlan();
}


void COpenGLControl::OnLButtonDown(UINT nFlags, CPoint point) {	
	if (wholeWindow->IsDlgButtonChecked(IDC_RADIO4) == BST_CHECKED) {
		if (exitsMarked<2)
			exitsMarked++;
		exit[exitArrayVal][0] = (point.x-121.0f)/121.0f;
		exit[exitArrayVal][1] = (point.y-100.0f)/100.0f;
		if (exitArrayVal<1)
			exitArrayVal++;
		else
			exitArrayVal--;
	} else {
		if (clustersMarked<40)
			clustersMarked++;
		people[peopleArrayVal][0] = (point.x-121.0f)/121.0f;
		people[peopleArrayVal][1] = (point.y-100.0f)/100.0f;
		if (peopleArrayVal<39)
			peopleArrayVal++;
		else
			peopleArrayVal=0;
	}
	CWnd::OnLButtonDown(nFlags,point);
}

void COpenGLControl::createFloorPlan() {
	if (glIsList(m_floorID)) {
		glDeleteLists(m_floorID, 1);
	}
	std::ifstream inf(m_floor, std::ios::in | std::ios::binary);
	char temp[256], testing[16]="\t\t\tSI_Mesh MSH-";
	//for (int k=16;k<256;k++)
	//	testing[k] = 0;
	char tab[1];
	int vertNum=0;
	float startX=0, startY=0, startZ=0, x=0, y=0, z=0;
	//testing = "\t\t\tSI_Mesh MSH-MAXSceneRoot.JointState { \0";
	inf.getline(temp,256);
	while (!inf.eof()) {
		int j;
		for (j=0; j<15; j++) {
			if (temp[j] != testing[j])
				break;
		}
		if (j == 15) {
			inf.getline(temp,256);
			inf.getline(temp,256);
			inf.getline(temp,256);
			inf.getline(temp,256);
			inf.get(tab[0]);
			inf.get(tab[0]);
			inf.get(tab[0]);
			inf.get(tab[0]);
			inf.get(tab[0]);
			inf >> vertNum;
			inf.getline(temp,256);
			inf.getline(temp,256);
			inf.get(tab[0]);
			inf.get(tab[0]);
			inf.get(tab[0]);
			inf.get(tab[0]);
			inf.get(tab[0]);
			inf >> startX;
			inf.getline(temp,256,',');
			inf >> startY;
			inf.getline(temp,256,',');
			inf >> startZ;
			inf.getline(temp,256);
			if (fabs(startX) > scaleFactor)
				scaleFactor = fabs(startX);
			if (fabs(startY) > scaleFactor)
				scaleFactor = fabs(startY);
			if (fabs(startZ) > scaleFactor)
				scaleFactor = fabs(startZ);
			break;
		}
		//for (int clear=0;clear<256;clear++)
		//	temp[clear]=0;
		inf.getline(temp,256);
	}
	if (vertNum > 0) {
		m_floorID = glGenLists(1);
		glNewList(m_floorID, GL_COMPILE);
			glBegin(GL_LINE_LOOP);
				glVertex3f(startX,startY,startZ);
				for (int i=1; i<vertNum; i++) {
					inf.get(tab[0]);
					inf.get(tab[0]);
					inf.get(tab[0]);
					inf.get(tab[0]);
					inf.get(tab[0]);
					inf >> x;
					inf.getline(temp,256,',');
					inf >> y;
					inf.getline(temp,256,',');
					inf >> z;
					inf.getline(temp,256);
					glVertex3f(x,y,z);
					if (fabs(x) > scaleFactor)
						scaleFactor = fabs(x);
					if (fabs(y) > scaleFactor)
						scaleFactor = fabs(y);
					if (fabs(z) > scaleFactor)
						scaleFactor = fabs(z);
				}
				//glVertex3f(startX,startY,startZ);
			glEnd();
		glEndList();
	} else {
		m_floor = "unchanged\\floor.xsi";
		createFloorPlan();
	}
}

void COpenGLControl::changeFloorPlanSource(CString floor) {
	int temp = floor.Find('\\');
	while (temp > -1) {
		floor.Insert(temp, '\\');
		temp = floor.Find('\\', temp+2);
	}
	m_floor = floor;
	createFloorPlan();
}

void COpenGLControl::DrawGLScene() {
	glClear(GL_COLOR_BUFFER_BIT
		 |  GL_DEPTH_BUFFER_BIT);

	glLoadIdentity();

	//***************************
	// DRAWING CODE
	//***************************
	glDisable(GL_CULL_FACE);
	glPushMatrix();
		glColor3f(1.0f,0.0f,0.0f);
		glScalef(1.0f/(scaleFactor+1.0f), 1.0f/(scaleFactor+1.0f), 1.0f/(scaleFactor+1.0f));
		glRotatef(90, 1.0f,0.0f,0.0f);
		glLineWidth(2.0f);
		glCallList(m_floorID);
	glPopMatrix();

	for (int i=0; i<exitsMarked; i++) {
		float rot=0;
		if (exit[i][1] > 0)
			rot = atan(exit[i][0]/exit[i][1])*180.0f/3.14159265f+180.0f;
		else if (exit[i][1] < 0)
			rot = atan(exit[i][0]/exit[i][1])*180.0f/3.14159265f;
		glPushMatrix();
			glTranslatef(exit[i][0], -exit[i][1], 0);
			glRotatef(rot,0.0f,0.0f,1.0f);
			glBegin(GL_TRIANGLES);
				glColor3f(0.0f,(GLfloat)i,1.0f);
				glVertex3f(0.1f,-0.1f,0.0f);
				glVertex3f(-0.1f,-0.1f,0.0f);
				glVertex3f(0.0f,0.1f,0.0f);
			glEnd();
		glPopMatrix();
	}

		glPointSize(4.0f);
	glBegin(GL_POINTS);
		glColor3f(0.0f,1.0f,0.0f);
		for (int i=0; i<clustersMarked; i++) {
			glVertex3f(people[i][0],-people[i][1],0.0f);
		}
	glEnd();
		glPointSize(1.0f);

/*	glBegin(GL_QUADS);
		glColor3f(1.0f,0.0f,0.0f);
		glVertex3f(-1.1f,-1.1,0.0f);
		glVertex3f(1.1f,-1.1f,0.0f);
		glVertex3f(1.1f,1.1f,0.0f);
		glVertex3f(-1.1f,1.1f,0.0f);
	glEnd();*/

	SwapBuffers(dc->m_hDC);
}

void COpenGLControl::Create(CRect rect, CWnd *parent) {
	CString className = AfxRegisterWndClass(
		CS_HREDRAW | CS_VREDRAW | CS_OWNDC,
		NULL,
		(HBRUSH)GetStockObject(BLACK_BRUSH),
		NULL);

	CreateEx(
		0,
		className,
		"OpenGL",
		WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
		rect,
		parent,
		0);
	wholeWindow = parent;
}

void COpenGLControl::OnPaint() {
	rotation += 0.01f;

	if (rotation >= 360.0f) {
		rotation -= 360.0f;
	}

	/** OpenGL section **/

	openGLDevice.makeCurrent();

	DrawGLScene();
}

void COpenGLControl::OnSize(UINT nType, int cx, int cy) {
	CWnd::OnSize(nType, cx, cy);
	
	if (cy == 0) {
		cy = 1;						
	}

	glViewport(0,0,cx,cy);	

	glMatrixMode(GL_PROJECTION);						
	glLoadIdentity();						

	glOrtho(-1.0f,1.0f,-1.0f,1.0f,1.0f,-1.0f);
//	gluPerspective(45.0f,cx/cy,0.1f,100.0f);

	glMatrixMode(GL_MODELVIEW);						
	glLoadIdentity();
}

int COpenGLControl::OnCreate(LPCREATESTRUCT lpCreateStruct) {
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	dc = new CClientDC(this);

	openGLDevice.create(dc->m_hDC);
	InitGL();

	return 0;
}

BOOL COpenGLControl::OnEraseBkgnd(CDC* pDC) {
	return TRUE;
}
